if ( "undefined" == typeof(SchuzakJp) ) { SchuzakJp = {}; }
if ( "undefined" == typeof(SchuzakJp.Restart) ) { SchuzakJp.Restart = {}; }


SchuzakJp.Restart.RestartApp = function(){

	const app = Components.classes["@mozilla.org/observer-service;1"]
						  .getService(Components.interfaces.nsIObserverService);
	if (app) {
		try {
			const abortQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
										.createInstance(Components.interfaces.nsISupportsPRBool);
			app.notifyObservers(abortQuit, "quit-application-requested", "restart");
			
			if (abortQuit.data) {
				return;
			}
		} catch(e) {
			
		}
	}
	
	const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						   .getService(Components.interfaces.nsIWindowMediator)
						   .getEnumerator(null);
	while (wins.hasMoreElements()) {
		var wNext = wins.getNext();
		if ( ("tryToClose" in wNext) && !wNext.tryToClose() ) {
			return;
		}
	}
	
	
	Components.classes["@mozilla.org/toolkit/app-startup;1"]
			  .getService(Components.interfaces.nsIAppStartup)
			  .quit(Components.interfaces.nsIAppStartup.eRestart | 
					Components.interfaces.nsIAppStartup.eAttemptQuit);

};


SchuzakJp.Restart.initAn = {

	_locale: "chrome://Restart/locale/restart.properties",
	
	
	onLoadAn: function(window) {
		const restartLabel = Components.classes["@mozilla.org/intl/stringbundle;1"]
									   .getService(Components.interfaces.nsIStringBundleService)
									   .createBundle(this._locale)
									   .GetStringFromName("restart.label");
		
		window.restartMenuId = window.NativeWindow.menu.add(restartLabel, null, SchuzakJp.Restart.RestartApp);
	},
	
	
	onUnloadAn: function() {
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator("navigator:browser");
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			
			try{
				win.NativeWindow.menu.remove(win.restartMenuId);
			}catch(e){
				
			}
			win.restartMenuId = null;
		}
	}

}


SchuzakJp.Restart.init = {

	_prefs: Components.classes["@mozilla.org/preferences-service;1"]
					  .getService(Components.interfaces.nsIPrefService)
					  .getBranch("extensions.restart.key."),
	
	_locale: "chrome://Restart/locale/restart.properties",
	_style: "chrome://Restart/skin/restart.css",
	
	
	onLoad: function(window) {
		SchuzakJp.Restart.init.setKey(window);
		
		SchuzakJp.Restart.init.setMenuItems(window);
		
		SchuzakJp.Restart.init.setPanelButton(window);
		
		SchuzakJp.Restart.init.setToolbarButton(window);
	},
	
	
	onUnload: function() {
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator(null);
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			
			SchuzakJp.Restart.init.removeKey(win);
			
			SchuzakJp.Restart.init.removeMenuItems(win);
			
			SchuzakJp.Restart.init.removePanelButton(win);
		}
		
		SchuzakJp.Restart.init.removeButtons();
	},
	
	
	_keysetID: "restartKeyset",
	_keyID: "key_restartApplication",
	
	
	setKey: function(window) {
		const prefs = this._prefs;
		if ( prefs.getBoolPref("enabled") ) {
			const keyChar  = prefs.getCharPref("char");
			var keyModifier;
			keyModifier = prefs.getBoolPref("mod.accel") ? "accel "              : "";
			keyModifier = prefs.getBoolPref("mod.alt")   ? keyModifier + "alt "  : keyModifier;
			keyModifier = prefs.getBoolPref("mod.shift") ? keyModifier + "shift" : keyModifier;
			
			if (keyChar != "" && keyModifier != "") {
				const doc = window.document;
				
				var defaultKeysetId;
				if ( doc.getElementById("mainKeyset") ) {
					defaultKeysetId = "mainKeyset";
				} else if ( doc.getElementById("mailKeys") ) {
					defaultKeysetId = "mailKeys";
				} else {
					return;
				}
				const keysets = doc.getElementById(defaultKeysetId).parentNode;
				
				const restartKeyset = doc.createElement("keyset");
				restartKeyset.setAttribute("id", this._keysetID);
				
				const restartKey = doc.createElement("key");
				restartKey.setAttribute("id", this._keyID);
				restartKey.setAttribute("key", keyChar);
				restartKey.setAttribute("modifiers", keyModifier);
				restartKey.setAttribute("oncommand", "void(0);");
				restartKey.addEventListener( "command", function(event) {
					SchuzakJp.Restart.RestartApp();
				}, false);
				
				keysets.appendChild(restartKeyset).appendChild(restartKey);
			}
		}
	},
	
	
	removeKey: function(window){
		const doc = window.document;
		
		var defaultKeysetId;
		if ( doc.getElementById("mainKeyset") ) {
			defaultKeysetId = "mainKeyset";
		} else if ( doc.getElementById("mailKeys") ) {
			defaultKeysetId = "mailKeys";
		} else {
			return;
		}
		const keysets = doc.getElementById(defaultKeysetId).parentNode;
		
		try {
			keysets.removeChild( doc.getElementById(this._keysetID) );
		} catch(e) {
			
		}
	},
	
	
	_targetMenuId: ["menu_FilePopup", "appmenuPrimaryPane"],
	_menuItemId: ["menu_restart", "appmenu-restart"],
	
	
	setMenuItems: function(window) {
		const doc = window.document;
		const targetMenuId = this._targetMenuId;
		const menuItemId   = this._menuItemId;
		const quitId       = ["menu_FileQuitItem", "appmenu-quit"];
		const StrB = Components.classes["@mozilla.org/intl/stringbundle;1"]
							   .getService(Components.interfaces.nsIStringBundleService)
							   .createBundle(this._locale);
		const restartLabel     = StrB.GetStringFromName("restart.label");
		const restartAccesskey = StrB.GetStringFromName("restart.accessKey");
		
		const targetMenuIdLen = targetMenuId.length;
		var targetMenu, newItem;
		for (let i = 0; i < targetMenuIdLen; i++) {
			targetMenu = doc.getElementById(targetMenuId[i]);
			if (targetMenu) {
				newItem = doc.createElement("menuitem");
				newItem.setAttribute("id", menuItemId[i]);
				newItem.setAttribute("label", restartLabel);
				if (i == 0) {
					restartAccesskey != "" ? newItem.setAttribute("accesskey", restartAccesskey) : null;
					newItem.setAttribute("key", this._keyID);
				}
				newItem.addEventListener( "command", function(event) {
					SchuzakJp.Restart.RestartApp();
				}, false);
				
				targetMenu.insertBefore( newItem, doc.getElementById(quitId[i]) );
			}
		}
	},
	
	
	removeMenuItems: function(window) {
		const doc = window.document;
		
		const targetMenuId = this._targetMenuId;
		const menuItemId   = this._menuItemId;
		
		const targetMenuIdLen = targetMenuId.length;
		for (let i = 0; i < targetMenuIdLen; i++) {
			try{
				doc.getElementById(targetMenuId[i]).removeChild( doc.getElementById(menuItemId[i]) );
			}catch(e){
				
			}
		}
	},
	
	
	setPanelButton: function(window) {
		const doc = window.document;
		const panelFooter = doc.getElementById("PanelUI-footer-inner");
		if (panelFooter) {
			const restartLabel = Components.classes["@mozilla.org/intl/stringbundle;1"]
										   .getService(Components.interfaces.nsIStringBundleService)
										   .createBundle(this._locale)
										   .GetStringFromName("restart.label");
			
			const panelButton = doc.createElement("toolbarbutton");
			panelButton.setAttribute("id", "PanelUI-restart");
			panelButton.setAttribute("label", restartLabel);
			panelButton.setAttribute("tooltiptext", restartLabel);
			panelButton.setAttribute("tabindex", "0");
			panelButton.setAttribute("disabled", true);
			panelButton.addEventListener( "command", function(event) {
					SchuzakJp.Restart.RestartApp();
			}, false);
			
			panelFooter.insertBefore( panelButton, doc.getElementById("PanelUI-quit") );
			
			
			const panelSeparator = doc.createElement("toolbarseparator");
			panelSeparator.setAttribute("id", "PanelUI-restart-separator");
			
			panelFooter.insertBefore( panelSeparator, doc.getElementById("PanelUI-quit") );
			
			
			window.addEventListener("beforecustomization", SchuzakJp.Restart.pBtnMgr.disable, false);
			doc.getElementById("PanelUI-popup").addEventListener("popupshowing", SchuzakJp.Restart.pBtnMgr.enable, false);
		}
	},
	
	
	removePanelButton: function(window) {
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator(null);
		var win, doc, panelFooter;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			doc = win.document;
			
			panelFooter = doc.getElementById("PanelUI-footer-inner");
			if ( panelFooter ) {
				win.removeEventListener("beforecustomization", SchuzakJp.Restart.pBtnMgr.disable);
				doc.getElementById("PanelUI-popup").removeEventListener("popupshowing", SchuzakJp.Restart.pBtnMgr.enable);
				
				try{
					panelFooter.removeChild( doc.getElementById("PanelUI-restart") );
					panelFooter.removeChild( doc.getElementById("PanelUI-restart-separator") );
				}catch(e){
					
				}
			}
		}
	},
	
	
	setToolbarButton: function(window) {
		const uri = window.document.documentURI;
		const restartLabel = Components.classes["@mozilla.org/intl/stringbundle;1"]
									   .getService(Components.interfaces.nsIStringBundleService)
									   .createBundle(this._locale)
									   .GetStringFromName("restart.label");
		
		var targetToolbox = null;
		if (uri == "chrome://messenger/content/messenger.xul") {
			targetToolbox = "mail-toolbox";
		}
		
		if (uri == "chrome://browser/content/browser.xul" || uri == "chrome://messenger/content/messenger.xul") {
			try{
				CustomizableUI.createWidget({
					toolbox: targetToolbox,
					id: "restart-button",
					label: restartLabel,
					tooltiptext: restartLabel,
					onCommand: function(event) {
						SchuzakJp.Restart.RestartApp();
					}
				});
			}catch(e){
				
			}
		}
	},
	
	
	removeButtons: function() {
		CustomizableUI.destroyWidget("restart-button");
	},
	
	
	handleStylesheet: function(action) {
		const sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
							  .getService(Components.interfaces.nsIStyleSheetService);
		const styleSheet = Components.classes["@mozilla.org/network/io-service;1"]
									 .getService(Components.interfaces.nsIIOService)
									 .newURI(this._style, null, null);
		
		if (action == "load") {
			sss.loadAndRegisterSheet(styleSheet, sss.AUTHOR_SHEET);
		} else {
			sss.unregisterSheet(styleSheet, sss.AUTHOR_SHEET);
		}
	},
	
	
	closeCustomizeWindow: function() {
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator(null);
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			if (win.document.documentURI == "chrome://global/content/customizeToolbar.xul") {
				win.close();
			}
		}
	}

};



SchuzakJp.Restart.pBtnMgr = {

	disable: function() {
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator("navigator:browser");
		var doc;
		while ( wins.hasMoreElements() ) {
			doc = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow).document;
			try{
				doc.getElementById("PanelUI-help").setAttribute("disabled", "true");
				doc.getElementById("PanelUI-restart").setAttribute("disabled", "true");
				doc.getElementById("PanelUI-quit").setAttribute("disabled", "true");
			}catch(e){
				
			}
		}
	},
	
	enable: function() {
		const doc = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							  .getService(Components.interfaces.nsIWindowMediator)
							  .getMostRecentWindow("navigator:browser")
							  .document;
		try{
			doc.getElementById("PanelUI-help").removeAttribute("disabled");
			doc.getElementById("PanelUI-restart").removeAttribute("disabled");
			doc.getElementById("PanelUI-quit").removeAttribute("disabled");
		}catch(e){
			
		}
	}

};


SchuzakJp.Restart.setPrefs = {

	set: function(pref, type, value){
		const prefs = Components.classes["@mozilla.org/preferences-service;1"]
								.getService(Components.interfaces.nsIPrefService)
								.getBranch("extensions.restart.key.");
		
		if(type == "bool"){
			try{
				var current = prefs.getBoolPref(pref);
			}catch(e){
				prefs.setBoolPref(pref, value);
			}
		}else if(type == "int"){
			try{
				var current = prefs.getIntPref(pref);
			}catch(e){
				prefs.setIntPref(pref, value);
			}
		}else if(type == "char"){
			try{
				var current = prefs.getComplexValue(pref, Components.interfaces.nsISupportsString).data;
			}catch(e){
				prefs.setCharPref(pref, value);
			}
		}
	},
	
	defaults: function(){
		this.set("enabled",   "bool", true);
		this.set("mod.accel", "bool", true);
		this.set("mod.alt",   "bool", true);
		this.set("mod.shift", "bool", false);
		this.set("char",      "char", "R");
	}

};


SchuzakJp.Restart.keyPrefObserver = {
	_prefs: Components.classes["@mozilla.org/preferences-service;1"]
					  .getService(Components.interfaces.nsIPrefService)
					  .getBranch("extensions.restart.key."),
	
	
	startup: function() {
		SchuzakJp.Restart.setPrefs.defaults();
		
		this._prefs.QueryInterface(Components.interfaces.nsIPrefBranch);
		this._prefs.addObserver("", this, false);
	},
	
	shutdown: function() {
		this._prefs.removeObserver("", this, false);
	},
	
	observe: function(aSubject, aTopic, aData) {
		SchuzakJp.Restart.setPrefs.defaults();
		
		const wins = Components.classes["@mozilla.org/appshell/window-mediator;1"]
							   .getService(Components.interfaces.nsIWindowMediator)
							   .getEnumerator(null);
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			
			SchuzakJp.Restart.init.removeMenuItems(win);
			SchuzakJp.Restart.init.removeKey(win);
			SchuzakJp.Restart.init.setKey(win);
			SchuzakJp.Restart.init.setMenuItems(win);
		}
	}
};


SchuzakJp.Restart.windowListenerAn = {
	onOpenWindow: function(aWindow) {
		const domWindow = aWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
								 .getInterface(Components.interfaces.nsIDOMWindowInternal || Components.interfaces.nsIDOMWindow);
		domWindow.addEventListener("load", function onDomWindowLoad() {
			domWindow.removeEventListener("load", onDomWindowLoad, false);
			
			SchuzakJp.Restart.initAn.onLoadAn(domWindow);
		}, false);
	},
	
	onCloseWindow: function(aWindow) {},
	
	onWindowTitleChange: function(aWindow, aTitle) {}
};


SchuzakJp.Restart.windowListener = {
	onOpenWindow: function(aWindow) {
		const domWindow = aWindow.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
								 .getInterface(Components.interfaces.nsIDOMWindowInternal || Components.interfaces.nsIDOMWindow);
		domWindow.addEventListener("load", function onDomWindowLoad() {
			domWindow.removeEventListener("load", onDomWindowLoad, false);
			
			SchuzakJp.Restart.init.onLoad(domWindow);
		}, false);
	},
	
	onCloseWindow: function(aWindow) {},
	
	onWindowTitleChange: function(aWindow, aTitle) {}
};



function startup(data, reason) {
	const wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						 .getService(Components.interfaces.nsIWindowMediator);
	
	
	const appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
							  .getService(Components.interfaces.nsIXULAppInfo);
	if (appInfo.ID == "{aa3c5121-dab2-40e2-81ca-7ea25febc110}") { //an
		wm.addListener(SchuzakJp.Restart.windowListenerAn);
		
		var wins = wm.getEnumerator("navigator:browser");
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			SchuzakJp.Restart.initAn.onLoadAn(win);
		}
		
	} else {
		SchuzakJp.Restart.init.closeCustomizeWindow();
		
		
		SchuzakJp.Restart.init.handleStylesheet("load"); //#1
		try {
			Components.utils.import("resource:///modules/CustomizableUI.jsm");
		} catch(e) {
			Components.utils.import("chrome://Restart/content/libBtn.jsm"); //#2
		}
		
		
		SchuzakJp.Restart.keyPrefObserver.startup(); //#3-1
		
		wm.addListener(SchuzakJp.Restart.windowListener); //#3-2
		
		var wins = wm.getEnumerator(null);
		var win;
		while ( wins.hasMoreElements() ) {
			win = wins.getNext().QueryInterface(Components.interfaces.nsIDOMWindow);
			SchuzakJp.Restart.init.onLoad(win); //#3-last
		}
	}
}


function shutdown(data, reason) {
	if (reason == APP_SHUTDOWN) {
		return;
	}
	
	const wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
						 .getService(Components.interfaces.nsIWindowMediator);
	
	
	const appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
							  .getService(Components.interfaces.nsIXULAppInfo);
	if (appInfo.ID == "{aa3c5121-dab2-40e2-81ca-7ea25febc110}") { //an
		wm.removeListener(SchuzakJp.Restart.windowListenerAn);
		
		SchuzakJp.Restart.initAn.onUnloadAn();
		
	} else {
		SchuzakJp.Restart.init.closeCustomizeWindow();
		
		
		wm.removeListener(SchuzakJp.Restart.windowListener); //#3-2
		
		SchuzakJp.Restart.keyPrefObserver.shutdown(); //#3-1
		
		SchuzakJp.Restart.init.onUnload(); //#3-last
		
		
		Components.utils.unload("chrome://Restart/content/libBtn.jsm"); //#2
		SchuzakJp.Restart.init.handleStylesheet("remove"); //#1
	}
	
	
	Components.classes["@mozilla.org/observer-service;1"]
			  .getService(Components.interfaces.nsIObserverService)
			  .notifyObservers(null, "chrome-flush-caches", null);
}


function install(data, reason) {}

function uninstall(data, reason) {}

